#include <iostream>
#include <sstream>

#include "vorbisStreamParameter.h"

VorbisStreamParameter::VorbisStreamParameter()
{
}

VorbisStreamParameter::~VorbisStreamParameter()
{
}


bool VorbisStreamParameter::operator==(const StreamParameter& _param)
{
  StreamParameter* _param_unconst = const_cast<StreamParameter*>(&_param);
  VorbisStreamParameter* param = dynamic_cast<VorbisStreamParameter*>(_param_unconst);

  if (!param)
    return(false);

  if (channels != param->channels) {
    std::cerr << "vorbis parameter compare: number of channels not matching "
              << channels << " != " << param->channels
              << std::endl;
    return(false);
  }

  if (rate != param->rate) {
    std::cerr << "vorbis parameter compare: sample rate not matching "
              << rate << " != " << param->rate
              << std::endl;
    return(false);
  }

  return(true);
}

std::string VorbisStreamParameter::toString()
{
  std::stringstream stream;
  stream << "Vorbis Stream:\n"
  << "\twith " << channels << " channels\n"
  << "\tand  " << rate << " kHz sample rate\n\n";

  return(stream.str());
}

StreamParameter* VorbisStreamParameter::clone()
{
  // create a clone object
  VorbisStreamParameter* streamParameter = new VorbisStreamParameter();

  // copy the original data to the clone
  (*streamParameter) = (*this);

  // return the clone
  return(streamParameter);
}
